'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var numberOfOptions = 0;

var TypeAhead = function (_React$Component) {
  _inherits(TypeAhead, _React$Component);

  function TypeAhead(props) {
    _classCallCheck(this, TypeAhead);

    var _this = _possibleConstructorReturn(this, (TypeAhead.__proto__ || Object.getPrototypeOf(TypeAhead)).call(this, props));

    _this.state = {
      shouldOptionsBeVisible: false,
      selectedindex: -1,
      inputValue: ''
    };

    _this.showOptions = _this.showOptions.bind(_this);
    _this.hideOptions = _this.hideOptions.bind(_this);

    _this.onFocus = _this.onFocus.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onKeyDown = _this.onKeyDown.bind(_this);
    _this.onMouseDown = _this.onMouseDown.bind(_this);
    _this.onMouseOver = _this.onMouseOver.bind(_this);

    _this.onSelect = _this.onSelect.bind(_this);
    _this.onSelectedindexUpdate = _this.props.onSelectedindexUpdate;
    return _this;
  }

  _createClass(TypeAhead, [{
    key: 'showOptions',
    value: function showOptions() {
      this.setState({
        shouldOptionsBeVisible: true
      });
      this.props.onExpand();
    }
  }, {
    key: 'hideOptions',
    value: function hideOptions() {
      this.setState({
        selectedindex: -1,
        shouldOptionsBeVisible: false
      });
      this.props.onCollapse();
    }
  }, {
    key: 'onFocus',
    value: function onFocus(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onFocus) {
        this.props.children[0].props.onFocus(e);
      }
      this.showOptions();
    }
  }, {
    key: 'onBlur',
    value: function onBlur(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onBlur) {
        this.props.children[0].props.onBlur(e);
      }
      this.hideOptions();
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onChange) {
        this.props.children[0].props.onChange(e);
      }
      this.setState({ inputValue: e.target.value });
      this.showOptions();
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(e) {
      /* istanbul ignore else */
      if (this.props.children[0].props.onKeyDown) {
        this.props.children[0].props.onKeyDown(e);
      }
      if (e.keyCode !== 13 && e.keyCode !== 27 && e.keyCode !== 38 && e.keyCode !== 40) {
        return;
      }

      e.preventDefault();

      if (e.keyCode === 27) {
        this.hideOptions();
        return;
      }

      if (e.keyCode === 13) {
        this.onSelect();
        return;
      }

      var selectedindex = void 0;

      if (e.keyCode === 38) {
        selectedindex = this.state.selectedindex - 1;
        if (selectedindex < 0) {
          selectedindex = numberOfOptions - 1;
        }
      }

      if (e.keyCode === 40) {
        selectedindex = this.state.selectedindex + 1;
        if (selectedindex > numberOfOptions - 1) {
          selectedindex = 0;
        }
      }

      this.setState({
        shouldOptionsBeVisible: true,
        selectedindex: selectedindex
      });
      this.onSelectedindexUpdate(selectedindex);
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown(e) {
      /* istanbul ignore else */
      if (this.props.children[1].props.onMouseDown) {
        this.props.children[1].props.onMouseDown(e);
      }
      e.preventDefault();
      this.onSelect();
    }
  }, {
    key: 'onMouseOver',
    value: function onMouseOver(e) {
      /* istanbul ignore else */
      if (this.props.children[1].props.onMouseOver) {
        this.props.children[1].props.onMouseOver(e);
      }
      var selectedindex = Number(e.target.getAttribute('data-index'));
      this.setState({
        selectedindex: selectedindex
      });
      this.onSelectedindexUpdate(selectedindex);
    }
  }, {
    key: 'onSelect',
    value: function onSelect() {
      var _this2 = this;

      this.props.onSelect(this.state.selectedindex);
      this.setState(function (prevState) {
        return {
          selectedindex: -1,
          shouldOptionsBeVisible: false,
          inputValue: _this2.props.clearInputOnSelect === true ? /* istanbul ignore next */'' : _this2.props.children[1].props.options[prevState.selectedindex]
        };
      });
    }
  }, {
    key: 'render',
    value: function render() {
      numberOfOptions = this.props.children[1].props.options.length || 0;

      var Input = _react2.default.cloneElement(this.props.children[0], {
        onFocus: this.onFocus,
        onBlur: this.onBlur,
        onChange: this.onChange,
        onKeyDown: this.onKeyDown,
        value: this.state.inputValue
      });

      var Options = _react2.default.cloneElement(this.props.children[1], {
        className: this.state.shouldOptionsBeVisible && numberOfOptions ? 'D(b)' : 'D(n)',
        selectedindex: this.state.selectedindex,
        onMouseDown: this.onMouseDown,
        onMouseOver: this.onMouseOver
      });

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'span',
          { className: 'Hidden', 'aria-live': 'assertive' },
          this.props.ariaLiveText
        ),
        Input,
        Options
      );
    }
  }]);

  return TypeAhead;
}(_react2.default.Component);

TypeAhead.propTypes = {
  onSelectedindexUpdate: _propTypes2.default.func.isRequired,
  onSelect: _propTypes2.default.func.isRequired,
  onExpand: _propTypes2.default.func.isRequired,
  onCollapse: _propTypes2.default.func.isRequired,

  children: _propTypes2.default.array.isRequired,

  ariaLiveText: _propTypes2.default.string.isRequired,
  clearInputOnSelect: _propTypes2.default.bool
};

TypeAhead.defaultProps = {
  clearInputOnSelect: false
};
exports.default = TypeAhead;